# Overview
`Projector` is a logic program rewriting tool designed to split a single rule into multiple rules with the goal that the number of variables present in each new rule is smaller than that of the original.

# Installation
The only dependency for `Projector` is `clingo` 5.3.0 (other version may work, but we have tested for this version). It must be installed with `Python` 2.7 enabled and the binary must be accessible to your python path.

The easiest way to install clingo into your python path is through `Anaconda`:
1. Install `Anaconda` for `Python` 2.7. `Anaconda` can be downloaded [here](https://www.anaconda.com/download/). Follow the instructions provided on the site for installation.
2. Install `clingo` 5.3.0 by running `conda install -c potassco clingo=5.3.0`. Release information for clingo can be found [here](https://github.com/potassco/clingo/releases).

# Running Projector
To run projector, simply execute `python projector.py (encoding-file)`.

Detailed usage info can be found by running `python projector.py --help`.

## Flags
There are many flags intended for debugging purposes. The following covers the flags relevant to most users.

`--instance` Specifies an additional file to include in grounding/solving. Projector will not rewrite these files. This flag may be provided multiple times if multiple instance files are to be used.

`--output` The output mode of the program (ground|solve|rewrite). Option `ground` will provide statistical info for the grounding process only. Option `solve` will provide statistical info for both grounding and solving. Option `rewrite` (default) will output the rewritten program.

`--max_atoms` Specifies the maximum order of any projection allowed to be performed for all rules in the program. Option `-1` can be used for infinity (default).

`--restrict` Specifies the type of projection to perform respectively (alpha|beta). Alpha-projection is default.

`--version` Displays the current version of `Projector`.

## Examples
`python projector.py examples/male_cousin.lp`
`python projector.py examples/male_cousin.lp --max_atoms 1`
`python projector.py examples/male_cousin.lp --restrict beta`

# The MIT License (MIT)

Copyright 2018 Nicholas Hippen

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.